import { Moment } from 'moment';
import { ITimeRecord, IProjects as IProject, ITimesheet, IOrgMember } from '@admin-layout/timetracker-core';
interface IProjectsApproval {
    approvals: Array<string>;
    unApprovals: Array<string>;
}
interface ITabularCalendar {
    weekStart: Moment;
    records: ITimeRecord[];
    projects: Array<IProject>;
    timesheets: Array<ITimesheet> | null;
    selectedUser: string;
    projectsApproval: IProjectsApproval;
    projectsMap: Map<string, IProject>;
    loading?: boolean;
    members: Array<IOrgMember>;
    handleRemoveDuration: Function;
    updateTimeRecord: Function;
    createTimeRecord: Function;
    createTimesheet: Function;
}
export declare const TabularCalendar: ({ weekStart, records, projects, timesheets, selectedUser, projectsApproval, projectsMap, members, handleRemoveDuration, updateTimeRecord, createTimeRecord, createTimesheet, }: ITabularCalendar) => JSX.Element;
export {};
//# sourceMappingURL=TabularCalendar.d.ts.map