import*as _ from'lodash';import React__default,{useEffect,useState}from'react';import {PageContainer}from'@admin-layout/components';import TabularCalendarWrapper from'./Tabular/index.js';import TimesheetCalendar from'./Calendar/index.js';import {useGetProjectsQuery,useGetOrganizationMembersQuery}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import {Spin,Row,Col,Switch,Form,Select}from'antd';import TimezonePicker from'react-timezone';import {momentLocalizer}from'react-big-calendar';import moment from'moment';export{default as moment}from'moment';import {useHistory,useLocation}from'react-router';import qs__default from'query-string';import {useFirstWeekDay,useViewPermissions}from'../../hooks/index.js';import {useSelector}from'react-redux';const Timesheet = ({ projects, members, localizer, weekStart, selectedUser, setSelectedUser, setPathWeekStart, }) => {
    const location = useLocation();
    const history = useHistory();
    const parsed = qs__default.parse(location.search);
    const [selectedProject, setSelectedProject] = useState('__all');
    const [isShowTimeModal, setIsShowTimeModal] = useState(false);
    const handleChangeViewMode = () => {
        parsed.view = parsed.view === 'calendar' ? 'tabular' : 'calendar';
        history.push({
            pathname: location.pathname,
            search: qs__default.stringify(parsed),
        });
    };
    const handleSelectTimezone = (timezone) => {
        // setLocalizer(momentLocalizer(moment.tz.setDefault(timezone)));
    };
    const handleChangeProject = (value) => {
        setSelectedProject(value);
    };
    const handleChangeSelectedUser = (value) => {
        setSelectedUser(value);
    };
    return (React__default.createElement(PageContainer, null,
        React__default.createElement(Row, { align: "middle", justify: "space-between", style: { marginBottom: '10px' } },
            React__default.createElement(Col, null,
                React__default.createElement(Switch, { checkedChildren: "Calendar View", unCheckedChildren: "Tabular View", checked: parsed.view === 'calendar', onChange: handleChangeViewMode }))),
        React__default.createElement(Row, { align: "middle", justify: "space-between", style: { marginBottom: '10px' } },
            React__default.createElement(Col, null,
                React__default.createElement("div", { style: { textAlign: 'center' } },
                    React__default.createElement("h3", null, "View & edit timesheets")))),
        React__default.createElement(Row, { align: "middle", gutter: [24, 16] },
            React__default.createElement(Col, { md: 4, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Timezone Picker" },
                        React__default.createElement(TimezonePicker, { value: "Asia/Yerevan", onChange: handleSelectTimezone, inputProps: {
                                placeholder: 'Select Timezone...',
                                name: 'timezone',
                            } })))),
            React__default.createElement(Col, { md: 4, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Members" },
                        React__default.createElement(Select, { onChange: handleChangeSelectedUser, value: selectedUser },
                            React__default.createElement(Select.Option, { value: "__all", key: "__all" }, "All"),
                            members.map((member) => {
                                return (React__default.createElement(Select.Option, { value: member.userId, key: member.userId }, member.name));
                            }))))),
            React__default.createElement(Col, { md: 4, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Projects" },
                        React__default.createElement(Select, { onChange: handleChangeProject, value: selectedProject },
                            React__default.createElement(Select.Option, { value: "__all" }, "All"),
                            projects.map((res) => {
                                return (React__default.createElement(Select.Option, { value: res.id, key: res.id }, res.name));
                            })))))),
        parsed.view === 'calendar' ? (React__default.createElement(TimesheetCalendar, { localizer: localizer, weekStart: weekStart, projects: projects, members: members, isShowTimeModal: isShowTimeModal, selectedUser: selectedUser, selectedProject: selectedProject, setIsShowTimeModal: setIsShowTimeModal, setPathWeekStart: setPathWeekStart })) : (React__default.createElement(TabularCalendarWrapper, { projects: projects, members: members, localizer: localizer, weekStart: weekStart, setPathWeekStart: setPathWeekStart, selectedUser: selectedUser, selectedProject: selectedProject }))));
};
const TimesheetPage = () => {
    const { data: projectsData, loading: loadingProjects } = useGetProjectsQuery();
    const { data: membersData, loading: loadingMembers } = useGetOrganizationMembersQuery();
    const { value: dowValue } = useFirstWeekDay();
    const history = useHistory();
    const queryParsed = qs__default.parse(location.search);
    const userId = useSelector((state) => state.user.auth0UserId);
    const { self: viewSelfPermit, others: viewOtherPermit } = useViewPermissions();
    const weekStart = () => {
        return queryParsed.weekStart ? moment(queryParsed.weekStart) : moment().startOf('week');
    };
    const selectedUser = () => {
        var _a;
        return (_a = queryParsed.username) !== null && _a !== void 0 ? _a : (viewSelfPermit === "Allow" /* Allow */ ? userId : '');
    };
    useEffect(() => {
        const queryParsed = qs__default.parse(location.search);
        if (queryParsed.strict === undefined || !queryParsed.strict) {
            queryParsed.weekStart = moment().startOf('week').format('YYYY-MM-DD');
            history.push({
                pathname: location.pathname,
                search: qs__default.stringify(queryParsed),
            });
        }
    }, [dowValue]);
    const setPathWeekStart = (newWeekStarts) => {
        const parsed = qs__default.parse(location.search);
        parsed.weekStart = moment(newWeekStarts).format('YYYY-MM-DD');
        history.push({
            pathname: location.pathname,
            search: qs__default.stringify(parsed),
        });
    };
    const setSelectedUser = (username) => {
        const parsed = qs__default.parse(location.search);
        parsed.username = username;
        history.push({
            pathname: location.pathname,
            search: qs__default.stringify(parsed),
        });
    };
    moment.locale('en', {
        week: {
            dow: dowValue,
        },
    });
    const localizerM = momentLocalizer(moment);
    const filteredProjects = () => {
        return [..._.get(projectsData, 'getProjects', []), { id: '', name: 'UnKnown' }];
    };
    const filteredMembers = () => {
        return _.get(membersData, 'getOrganizationMembers', []).filter((member) => {
            if (viewOtherPermit === "Allow" /* Allow */ && member.userId !== userId)
                return true;
            if (viewSelfPermit === "Allow" /* Allow */ && member.userId === userId)
                return true;
            return false;
        });
    };
    return (React__default.createElement(Spin, { spinning: loadingProjects || loadingMembers },
        React__default.createElement(Timesheet, { projects: filteredProjects(), members: filteredMembers(), localizer: localizerM, weekStart: weekStart(), selectedUser: selectedUser(), setPathWeekStart: setPathWeekStart, setSelectedUser: setSelectedUser })));
};export default TimesheetPage;//# sourceMappingURL=index.js.map
