import {useState,useEffect}from'react';import {useSetting,usePermissionAutoFetch}from'@adminide-stack/platform-browser/lib/components';import'react-router';import {IPreDefineAccountPermissions}from'../constants/enums.js';import*as _ from'lodash';const useTimeformat = () => {
    //   const [timeFormat, setTimeformat] = useState('HH:mm:ss');
    //   const [dateFormat, setDateformat] = useState('YYYY-MM-DD');
    const { data: timeFormatData, loading: loadingTimeFormat } = useSetting({
        configKey: 'timetracker.project.timeFormat',
    });
    const { data: dateFormatData, loading: loadingDateFormat } = useSetting({
        configKey: 'timetracker.project.dateFormat',
    });
    return {
        timeFormat: !timeFormatData || loadingDateFormat ? 'HH:mm:ss' : timeFormatData === null || timeFormatData === void 0 ? void 0 : timeFormatData.resolveConfiguration,
        dateFormat: !dateFormatData || loadingDateFormat ? 'YYYY-MM-DD' : dateFormatData === null || dateFormatData === void 0 ? void 0 : dateFormatData.resolveConfiguration,
    };
};
const useFirstWeekDay = () => {
    const { data, loading } = useSetting({
        configKey: 'timetracker.project.firstDayOfTheWeek',
    });
    let value = 0;
    if (data && (data === null || data === void 0 ? void 0 : data.resolveConfiguration) === 'Monday')
        value = 1;
    else if (data && (data === null || data === void 0 ? void 0 : data.resolveConfiguration) === 'Tuesday')
        value = 2;
    else if (data && (data === null || data === void 0 ? void 0 : data.resolveConfiguration) === 'Wednesday')
        value = 3;
    else if (data && (data === null || data === void 0 ? void 0 : data.resolveConfiguration) === 'Thursday')
        value = 4;
    else if (data && (data === null || data === void 0 ? void 0 : data.resolveConfiguration) === 'Friday')
        value = 5;
    else if (data && (data === null || data === void 0 ? void 0 : data.resolveConfiguration) === 'Saturday')
        value = 6;
    return {
        day: (data === null || data === void 0 ? void 0 : data.resolveConfiguration) || 'Sunday',
        value,
    };
};
const useRound = () => {
    const { data: data, loading: loadingRoundData } = useSetting({
        configKey: 'timetracker.project.roundedToNearest',
    });
    const { data: typeData, loading: loadingRoundType } = useSetting({
        configKey: 'timetracker.project.roundedType',
    });
    const { data: roundedData, loading: loadingRounded, refetch: refetchRounded } = useSetting({
        configKey: 'timetracker.report.timeRoundingInReports',
    });
    const [roundType, setRoundType] = useState('ceil');
    const [roundValue, setRoundValue] = useState(60 /* IN_MINUTES_1 */);
    const [rounded, setRounded] = useState(false);
    useEffect(() => {
        if (data && (data === null || data === void 0 ? void 0 : data.resolveConfiguration))
            setRoundValue(data === null || data === void 0 ? void 0 : data.resolveConfiguration);
        if (typeData && (typeData === null || typeData === void 0 ? void 0 : typeData.resolveConfiguration)) {
            if ((typeData === null || typeData === void 0 ? void 0 : typeData.resolveConfiguration) === "Round up to" /* ROUND_UP_TO */)
                setRoundType('ceil');
            else if ((typeData === null || typeData === void 0 ? void 0 : typeData.resolveConfiguration) === "Round to nearest" /* ROUND_TO_NEAREST */)
                setRoundType('round');
            else if ((typeData === null || typeData === void 0 ? void 0 : typeData.resolveConfiguration) === "Roudn down to" /* ROUND_DOWN_TO */)
                setRoundType('floor');
        }
        setRounded(roundedData && (roundedData === null || roundedData === void 0 ? void 0 : roundedData.resolveConfiguration) !== undefined ? roundedData === null || roundedData === void 0 ? void 0 : roundedData.resolveConfiguration : false);
    }, [loadingRoundData, loadingRoundType, loadingRounded]);
    useEffect(() => {
        setRounded(roundedData && (roundedData === null || roundedData === void 0 ? void 0 : roundedData.resolveConfiguration) !== undefined ? roundedData === null || roundedData === void 0 ? void 0 : roundedData.resolveConfiguration : false);
    }, [loadingRounded, roundedData]);
    return {
        roundType,
        roundValue,
        rounded,
        refetchRounded,
        setRounded,
    };
};
const useViewPermissions = () => {
    const { data: selfData, loading: loadingSelf } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.viewSelfTimeTracker,
    });
    const { data: othersData, loading: loadingOthers } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.viewOthersTimeTracker,
    });
    const [selfPer, setSelfPer] = useState('');
    const [othersPer, setOthersPer] = useState('');
    useEffect(() => {
        setSelfPer(_.get(selfData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [selfData, loadingSelf]);
    useEffect(() => {
        setOthersPer(_.get(othersData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [othersData, loadingOthers]);
    return {
        self: selfPer,
        others: othersPer,
    };
};
const useCreatePermissions = () => {
    const { data: selfData, loading: loadingSelf } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.createSelfTimeTracker,
    });
    const { data: othersData, loading: loadingOthers } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.createOthersTimeTracker,
    });
    const [selfPer, setSelfPer] = useState('');
    const [othersPer, setOthersPer] = useState('');
    useEffect(() => {
        setSelfPer(_.get(selfData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [selfData, loadingSelf]);
    useEffect(() => {
        setOthersPer(_.get(othersData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [othersData, loadingOthers]);
    return {
        self: selfPer,
        others: othersPer,
    };
};
const useManagePermissions = () => {
    const { data: selfData, loading: loadingSelf } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.manageSelfTimeTracker,
    });
    const { data: othersData, loading: loadingOthers } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.manageOthersTimeTracker,
    });
    const [selfPer, setSelfPer] = useState('');
    const [othersPer, setOthersPer] = useState('');
    useEffect(() => {
        setSelfPer(_.get(selfData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [selfData, loadingSelf]);
    useEffect(() => {
        setOthersPer(_.get(othersData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [othersData, loadingOthers]);
    return {
        self: selfPer,
        others: othersPer,
    };
};
const useDeletePermissions = () => {
    const { data: selfData, loading: loadingSelf } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.deleteSelfTimeTracker,
    });
    const { data: othersData, loading: loadingOthers } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.deleteOthersTimeTracker,
    });
    const [selfPer, setSelfPer] = useState('');
    const [othersPer, setOthersPer] = useState('');
    useEffect(() => {
        setSelfPer(_.get(selfData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [selfData, loadingSelf]);
    useEffect(() => {
        setOthersPer(_.get(othersData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [othersData, loadingOthers]);
    return {
        self: selfPer,
        others: othersPer,
    };
};export{useCreatePermissions,useDeletePermissions,useFirstWeekDay,useManagePermissions,useRound,useTimeformat,useViewPermissions};//# sourceMappingURL=index.js.map
